#include "FreeRTOS.h"
#include "task.h"
#include "FreeRTOS_IP.h"
#include "FreeRTOS_IP_Private.h"
#include "NetworkBufferManagement.h"

#include "m4G_PPPOS/pico_dev_ppp.h"
#include "m4G_PPPOS/m4G_PPPOS.h"

//ʼ Ӻ
BaseType_t xNetworkInterfaceInitialise(void)
{
	return pdPASS;
}

//ͺ
BaseType_t xNetworkInterfaceOutput(NetworkBufferDescriptor_t * const pxDescriptor,
                                   BaseType_t xReleaseAfterSend)
{
  if((m4G_PPPOS->link_state(m4G_PPPOS) != 0) && (pxDescriptor->pucEthernetBuffer[12] == 0x08) && (pxDescriptor->pucEthernetBuffer[13] == 0x00))
  {
    m4G_PPPOS->send(m4G_PPPOS, pxDescriptor->pucEthernetBuffer + 14, pxDescriptor->xDataLength - 14);
  }
  
	if(xReleaseAfterSend != pdFALSE)  //ͷͻ
	{
	  vReleaseNetworkBufferAndDescriptor(pxDescriptor); 
	}
	
	return pdTRUE;
}

//ʹBufferAllocation_1ʵ
void vNetworkInterfaceAllocateRAMToBuffers( NetworkBufferDescriptor_t 
	     pxNetworkBuffers[ ipconfigNUM_NETWORK_BUFFER_DESCRIPTORS ] )
{
	mError("Error: vNetworkInterfaceAllocateRAMToBuffers()\n");
}

//ʵֵ
BaseType_t xGetPhyLinkStatus( void )
{
  if(m4G_PPPOS->link_state(m4G_PPPOS) == 0)
  {
    return pdFALSE;
  }
  
	return pdTRUE;
}

void vNetworkInterfaceInput(struct pico_device *self, void *buf, int len)
{
  static const u8 mac[14] = {0x12, 0x34, 0x56, 0x78, 0x9A, 0xBC, 0xBC, 0x9A, 0x78, 0x56, 0x34, 0x12, 0x08, 0x00};
  
  NetworkBufferDescriptor_t *pxBufferDescriptor = NULL;
  IPStackEvent_t xRxEvent;
  
  pxBufferDescriptor = pxGetNetworkBufferWithDescriptor(len + 14, 0);
  if(pxBufferDescriptor != NULL)
  {
    memcpy(pxBufferDescriptor->pucEthernetBuffer, mac, 14);
    memcpy(pxBufferDescriptor->pucEthernetBuffer + 14, buf, len);
    
    if(eConsiderFrameForProcessing(pxBufferDescriptor->pucEthernetBuffer) == eProcessBuffer)  //ж̫֡Ƿ
    {
      xRxEvent.eEventType = eNetworkRxEvent,
      xRxEvent.pvData     = ( void * ) pxBufferDescriptor;
      if(xSendEventStructToIPTask(&xRxEvent, 0) != pdTRUE)  //ݷ͵TCP/IPջ
      {
        vReleaseNetworkBufferAndDescriptor(pxBufferDescriptor);  //ͷͻ
      }
    }
    else  //֡
    {
      vReleaseNetworkBufferAndDescriptor(pxBufferDescriptor);  //ͷͻ
    }
  }
  else
  {
    mError("Error: pxBufferDescriptor == NULL\n");
  }
}














