/*
 * FreeRTOS Kernel V10.2.1
 * Copyright (C) 2019 Amazon.com, Inc. or its affiliates.  All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * http://www.FreeRTOS.org
 * http://aws.amazon.com/freertos
 *
 * 1 tab == 4 spaces!
 */

#ifndef FREERTOS_CONFIG_H
#define FREERTOS_CONFIG_H

#include "public.h"

/*-----------------------------------------------------------
 * Application specific definitions.
 *
 * These definitions should be adjusted for your particular hardware and
 * application requirements.
 *
 * THESE PARAMETERS ARE DESCRIBED WITHIN THE 'CONFIGURATION' SECTION OF THE
 * FreeRTOS API DOCUMENTATION AVAILABLE ON THE FreeRTOS.org WEB SITE. 
 *
 * See http://www.freertos.org/a00110.html
 *----------------------------------------------------------*/

/* Co-routine definitions. */
#define configUSE_CO_ROUTINES  0  //ʹЭ

/* ʹܶ */
#define configUSE_APPLICATION_TASK_TAG			   0  //ǩ
#define configUSE_COUNTING_SEMAPHORES          1  //ź
#define configUSE_MUTEXES                      0  //ź
#define configUSE_RECURSIVE_MUTEXES            0  //ݹ黥ź
#define configUSE_QUEUE_SETS                   1  //м
#define configUSE_TASK_NOTIFICATIONS           1  //֪ͨ
#define configTASK_NOTIFICATION_ARRAY_ENTRIES  1  //ÿ֪ͨ

#define configUSE_PREEMPTION	   0  //ʹʱƬ,߱ͬʱΪ1
#define configUSE_TIME_SLICING   0  //ʹʱƬ,߱ͬʱΪ1

#define configUSE_PORT_OPTIMISED_TASK_SELECTION  1  //Ӳǰ

#define configIDLE_SHOULD_YIELD  0  //ΪͬȼûóCPUʹȨ
#define configUSE_TICKLESS_IDLE  0  //ʹܵ͹ticklessģʽ

/* Թܶ */
#define configUSE_TRACE_FACILITY	            1  //ʹÿӻٵ
#define configUSE_STATS_FORMATTING_FUNCTIONS	0
#define configQUEUE_REGISTRY_SIZE             0  //ʹں˵Ϊ0

/* Memory allocation related definitions. */
#define configSUPPORT_STATIC_ALLOCATION   0  //ʹö̬ں˶
#define configSUPPORT_DYNAMIC_ALLOCATION  1  //ں˶RAMOSз
/* ڴѷheap_5.c93 */
#define configAPPLICATION_ALLOCATED_HEAP  0  //ɱڴ
#define configTOTAL_HEAP_SIZE             (1024 * 8)  //OSڴѴС(ֽ),ʹheap_5Ч

/* Hook function related definitions. */
#define configUSE_IDLE_HOOK			            0  //ʹܿӺ
#define configUSE_MALLOC_FAILED_HOOK        1  //ʹڴ䲻Ӻ
#define configCHECK_FOR_STACK_OVERFLOW      2  //ʹöջⷽ2ʹܶջӺ
#define configUSE_TICK_HOOK			            0  //ʹʱƬӺ
#define configUSE_DAEMON_TASK_STARTUP_HOOK  0

#define configCPU_CLOCK_HZ			       72000000  //ϵͳʱ
#define configTICK_RATE_HZ			       100  //δʱƵ
#define configTICK_PERIOD              10  //(1000 / configTICK_RATE_HZ)
#define configUSE_16_BIT_TICKS		     0  //32λδʱ
#define configOVERRIDE_DEFAULT_TICK_CONFIGURATION  1  //Լʼδʱ,ûʵֵ͹Ĳֺ
#define configGENERATE_RUN_TIME_STATS  0  //ʱͳƹ

/* FreeRTOSȼΪconfigMAX_PRIORITIES-1,ȼΪ0 */
#define configMAX_PRIORITIES		       4    //ȼ(Ҫ32),ΪһӦõСֵ
#define configMINIMAL_STACK_SIZE	     128  //Сջ
#define configMAX_TASK_NAME_LEN		     32   //󳤶

/* Software timer related definitions. */
#define configUSE_TIMERS  0  //ʹʱ

/* Set the following definitions to 1 to include the API function, or zero
to exclude the API function. */
#define INCLUDE_xSemaphoreGetMutexHolder      0  //xQueueGetMutexHolder()
#define INCLUDE_xTaskAbortDelay               0  //xTaskAbortDelay()
#define INCLUDE_vTaskDelay                    1  //vTaskDelay()
#define INCLUDE_vTaskDelayUntil               0  //vTaskDelayUntil()
#define INCLUDE_vTaskDelete                   1  //vTaskDelete()
#define INCLUDE_xTaskGetCurrentTaskHandle     1  //xTaskGetCurrentTaskHandle()
#define INCLUDE_xTaskGetHandle                0  //xTaskGetHandle()
#define INCLUDE_xTaskGetIdleTaskHandle        0  //xTaskGetIdleTaskHandle()
#define INCLUDE_xTaskGetSchedulerState        0  //xTaskGetSchedulerState()
#define INCLUDE_uxTaskGetStackHighWaterMark   1  //uxTaskGetStackHighWaterMark()
#define INCLUDE_vTaskPrioritySet              0  //vTaskPrioritySet()
#define INCLUDE_uxTaskPriorityGet             0  //vTaskPrioritySet()
#define INCLUDE_xResumeFromISR                0  //xResumeFromISR()
#define INCLUDE_eTaskGetState                 0  //eTaskGetState()
#define INCLUDE_vTaskSuspend                  0  //vTaskSuspend()
#define INCLUDE_xTimerPendFunctionCall        0  //xTimerPendFunctionCall()
#define INCLUDE_vTaskCleanUpResources			    0

/* Դ,ôȼλOSɹĴȼж */
#define configPRIO_BITS                       4     //MCUʹüλȼ
#define configKERNEL_INTERRUPT_PRIORITY 		  0xF0  //0xF<<4, STM32ʹø4λȼ
#define configMAX_SYSCALL_INTERRUPT_PRIORITY  0x80  //0x8<<4, OSɹȼ

/* MPU ݲ */
//#define configENFORCE_SYSTEM_CALLS_FROM_KERNEL_ONLY	 1
//#define configTOTAL_MPU_REGIONS					             16
//#define configTEX_S_C_B_SRAM						             0x03


#endif /* FREERTOS_CONFIG_H */














