#include "TcpUdpTest.h"
#include "FreeRTOS.h"
#include "task.h"
//#include "semphr.h"
#include "FreeRTOS_IP.h"
#include "FreeRTOS_Sockets.h"

static const u8 testRemoteIp[8] = {39, 106, 154, 231};
static const u16 testRemotePort = 5000;

#define TEST_BUFFER_SIZE 128
static u8 testBuffer[TEST_BUFFER_SIZE] = {0};

void tcpClientTestTask(void *pvParameters)
{
  vTaskDelay(1);
  
  Socket_t socket;
  struct freertos_sockaddr remoteAdd;
  
  while(1)
  {
    //ԶIPͶ˿ڹ̶
    remoteAdd.sin_addr = FreeRTOS_inet_addr_quick(testRemoteIp[0], testRemoteIp[1], testRemoteIp[2], testRemoteIp[3]);
    remoteAdd.sin_port = FreeRTOS_htons(testRemotePort);
    
    socket = FreeRTOS_socket(FREERTOS_AF_INET,
                             FREERTOS_SOCK_STREAM,  //TCP
                             FREERTOS_IPPROTO_TCP); 
  
    configASSERT(socket != FREERTOS_INVALID_SOCKET);

    /* ÷ͺͽճʱ,ճʱ1500msΪӷ,Խ÷vTaskDelay() */
    static const TickType_t sendTimOut = pdMS_TO_TICKS(2000), recvTimOut = pdMS_TO_TICKS(1500);  //ms
    FreeRTOS_setsockopt(socket, 0, FREERTOS_SO_RCVTIMEO, &recvTimOut, sizeof(recvTimOut));
    FreeRTOS_setsockopt(socket, 0, FREERTOS_SO_SNDTIMEO, &sendTimOut, sizeof(sendTimOut));

    /* ipconfigUSE_TCP_WINΪ1,FREERTOS_SO_WIN_PROPERTIES 
       FreeRTOS_setsockopt()һʹ,ԸĻڵĬϴС */

    if(FreeRTOS_connect(socket, &remoteAdd, sizeof(remoteAdd)) == 0)
    {
      mPrintf("tcp client test connect succ\n");
      u16 msBck = 0, msNow = 0;
      while(1)
      {
        vTaskDelay(1);  //ʹ÷,ԵvTaskDelay()
        
        int rxLen = FreeRTOS_recv(socket, testBuffer, TEST_BUFFER_SIZE, FREERTOS_MSG_DONTWAIT);  //
        if(rxLen > 0)
        {
          msBck = mSysTimerGetMs();
          FreeRTOS_send(socket, testBuffer, rxLen, 0);  //
        }
        else if(rxLen == 0)
        {
          //ճʱûյ
        }
        else if(rxLen < 0)
        {
          /* (Ҳӵ׽Ѿر˸׽),ػ */
          break;
        }
        
        msNow = mSysTimerGetMs();
        if((u16)(msNow - msBck) > 5000)
        {
          msBck = msNow;
          FreeRTOS_send(socket, testBuffer, 8, 0);  //
        }
      }
      
      FreeRTOS_shutdown(socket, FREERTOS_SHUT_RDWR);  //ػ

      TickType_t xTimeOnShutdown = xTaskGetTickCount();
      do {
        if(FreeRTOS_recv(socket, testBuffer, TEST_BUFFER_SIZE, 0) < 0)
        {
          break;
        }
      } while((xTaskGetTickCount() - xTimeOnShutdown) < pdMS_TO_TICKS(5000));
    }
    FreeRTOS_closesocket(socket);
    
    vTaskDelay(pdMS_TO_TICKS(1500));  //ʱ1.5s
  }
}

void udpTestTask(void *pvParameters)
{
  vTaskDelay(1);
  
  Socket_t socket;
  struct freertos_sockaddr localAdd, remoteAdd, rxSourceAdd;
  u32 rxSourceAddLen = sizeof(rxSourceAdd);
  
  //ԶIPͶ˿ڹ̶
  remoteAdd.sin_addr = FreeRTOS_inet_addr_quick(testRemoteIp[0], testRemoteIp[1], testRemoteIp[2], testRemoteIp[3]);
  remoteAdd.sin_port = FreeRTOS_htons(testRemotePort);
  
  socket = FreeRTOS_socket(FREERTOS_AF_INET,
                           FREERTOS_SOCK_DGRAM,  //UDP
                           FREERTOS_IPPROTO_UDP);
  
  configASSERT(socket != FREERTOS_INVALID_SOCKET);
  
  static const TickType_t sendTimOut = pdMS_TO_TICKS(2000), recvTimOut = 1;  //ms
  FreeRTOS_setsockopt(socket, 0, FREERTOS_SO_RCVTIMEO, &recvTimOut, sizeof(recvTimOut));
  FreeRTOS_setsockopt(socket, 0, FREERTOS_SO_SNDTIMEO, &sendTimOut, sizeof(sendTimOut));
  
  /* Bind the socket to port */
  localAdd.sin_port = FreeRTOS_htons(12345);
  FreeRTOS_bind(socket, &localAdd, sizeof(localAdd));
  
  u8 *rxPoint = NULL;
  u16 msBck = 0, msNow = 0;
  while(1)
  {
    int rxLen = FreeRTOS_recvfrom(socket, &rxPoint, 0, FREERTOS_ZERO_COPY, &rxSourceAdd, &rxSourceAddLen);
    if(rxLen > 0)
    {
      msBck = mSysTimerGetMs();
      memcpy(testBuffer, rxPoint, rxLen);
      FreeRTOS_sendto(socket, testBuffer, rxLen, 0, &remoteAdd, sizeof(remoteAdd));  //
    }
    if(rxLen >= 0)
    {
      /* Return the buffer to the TCP/IP stack. */
      FreeRTOS_ReleaseUDPPayloadBuffer(rxPoint);
    }
    
    msNow = mSysTimerGetMs();
    if((u16)(msNow - msBck) > 5000)
    {
      msBck = msNow;
      FreeRTOS_sendto(socket, testBuffer, 8, 0, &remoteAdd, sizeof(remoteAdd));  //
    }
  }
}














