#include "m4G_PPPOS/m4G_PPPOS.h"
#include "mDriver/mUSART1.h"

struct pico_device *m4G_PPPOS = NULL;

TaskHandle_t networkInterfaceInputHandler = NULL;

extern void vNetworkInterfaceInput(struct pico_device *self, void *buf, int len);

static int modem_read(struct pico_device *dev, void *data, int len)
{
  return mU1_ReadData(data, len);
}

static int modem_write(struct pico_device *dev, const void *data, int len)
{
//  if(dev->link_state(m4G_PPPOS) == 0)
  {
    return mU1_BlockSend(len, (u8*)data);
  }
//  
//  if(mU1_TxDmaIsBusy() == BOOL_TRUE)
//  {
//    return 0;
//  }
//  
//  return mU1_DMA_Send(len, (u8*)data);
}

//void m4G_PPPOS_Init(void)
//{
//  mUSART1_Config(115200);
//  mU1_DMA_RecvInit();
//  mU1_DMA_SendInit();
//  mU1_DMA_EnRecv();
//  
//  const char *apn = "CMNET";
//  const char *passwd = "admin";
//  const char *username = "admin";
//  
//  ppp = pico_ppp_create();
//  if(ppp == NULL)
//  {
//    mError("Error: ppp = pico_ppp_create()\n");
//    return;
//  }
//  
//  pico_ppp_set_serial_read(ppp, modem_read);
//  pico_ppp_set_serial_write(ppp, modem_write);
//  pico_ppp_set_serial_set_speed(ppp, NULL);
//  
//  pico_ppp_set_apn(ppp, apn);
//  pico_ppp_set_password(ppp, passwd);
//  pico_ppp_set_username(ppp, username);
//  
//  pico_ppp_connect(ppp);
//}

//void m4G_PPPOS_Task(void)
//{
//  static u16 msNow = 0, msBck = 0;
//  
//  msNow = mSysTimerGetMs();
//  if((u16)(msNow - msBck) >= 1000)
//  {
//    msBck = msNow;
//    pico_ppp_tick(ppp);
//  }
//  
//  pico_ppp_poll(ppp, 1);
//}

void m4G_PPPOS_Task(void *pvParameter)
{
  mUSART1_Config(921600);
  mU1_DMA_RecvInit();
  mU1_DMA_SendInit();
  mU1_DMA_EnRecv();
  
  const char *apn = "CMNET";
  const char *passwd = "admin";
  const char *username = "admin";
  
  m4G_PPPOS = pico_ppp_create();
  if(m4G_PPPOS == NULL)
  {
    mError("Error: m4G_PPPOS = pico_ppp_create()\n");
    return;
  }
  
  pico_ppp_set_serial_read(m4G_PPPOS, modem_read);
  pico_ppp_set_serial_write(m4G_PPPOS, modem_write);
  pico_ppp_set_serial_set_speed(m4G_PPPOS, NULL);
  
  pico_ppp_set_apn(m4G_PPPOS, apn);
  pico_ppp_set_password(m4G_PPPOS, passwd);
  pico_ppp_set_username(m4G_PPPOS, username);
  
  pico_ppp_set_ipRecvCallBack(m4G_PPPOS, vNetworkInterfaceInput);
  
  pico_ppp_connect(m4G_PPPOS);
  
  static u16 msNow = 0, msBck = 0;
  while(1)
  {
    ulTaskNotifyTake(pdFALSE, pdMS_TO_TICKS(1000 - (u16)(msNow - msBck)));  //ȴ֪ͨ
    msNow = mSysTimerGetMs();
    if((u16)(msNow - msBck) >= 1000)
    {
      msBck = msNow;
      m4G_PPPOS->tick(m4G_PPPOS);
    }
    
    m4G_PPPOS->poll(m4G_PPPOS, 0x7FFFFFFF);
  }
}










