#include "stm32f10x.h"
#include "public.h"
#include "FreeRTOS.h"
#include "task.h"
#include "FreeRTOS_IP.h"
#include "FreeRTOSIPConfig.h"
#include "m4G_PPPOS/m4G_PPPOS.h"
#include "TcpUdpTest.h"

int main(void)
{
	SystemInit();
  mSysTimerCfg();
	delay_ms(10);
  
	mNVIC_config();
//	mIWDG_config(5, 625);  //Ź2sʱ
	mUSART2_config(921600);
	mPrintf("start...\r\n");
  
  u8 ip[4] = {192, 168, 1, 1};
  u8 subMsk[4] = {255, 255, 255, 0};
  u8 mac[6] = {0x12, 0x34, 0x56, 0x78, 0x9A, 0xBC};
  ipconfigUSE_DHCP_Variable = 0;
	FreeRTOS_IPInit(ip, subMsk, ip, ip, mac);
  
  xTaskCreate(m4G_PPPOS_Task, "m4G_PPPOS_Task", 256, NULL, (configMAX_PRIORITIES - 1), &networkInterfaceInputHandler);
  xTaskCreate(tcpClientTestTask, "tcpClientTestTask", 128, NULL, (configMAX_PRIORITIES - 1), NULL);
//  xTaskCreate(udpTestTask, "udpTestTask", 128, NULL, (configMAX_PRIORITIES - 1), NULL);
  
	vTaskStartScheduler();
  
  while(1)
  {
		mError("Error: FreeRTOS Start Failed\n");
    delay_ms(100);  //ȴӡFIFO
    NVIC_SystemReset();
  }
}















