#include "public.h"

const u32 M0xFFFFFFFF = 0xFFFFFFFF;

#if SYSTEM_SUPPORT_OS == USE_OS_NONE
  static const u32 tickReloadVal = 0x00FFFFFF;  //ʼϵͳʱʱʹ
#else
  #include "FreeRTOSConfig.h"  //configTICK_RATE_HZ
  static const u32 tickReloadVal = (72000000 / 8 / configTICK_RATE_HZ);  //ʼϵͳʱʱʹ
#endif
void mSysTimerCfg(void)
{
  //ϵͳmsʱ
  {
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);

    TIM_TimeBaseInitStructure.TIM_Period = 0xFFFF;
    TIM_TimeBaseInitStructure.TIM_Prescaler = 0;
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;  //벶ʱ˲õ
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM4, &TIM_TimeBaseInitStructure);
    
    /* Slave Mode selection: TIM4 */
    TIM_SelectInputTrigger(TIM4, TIM_TS_ITR2);
    TIM_SelectSlaveMode(TIM4, TIM_SlaveMode_External1);
    
//    TIM_ClearITPendingBit(TIM4, TIM_IT_Update);
    TIM4->CNT = 0;
    TIM_Cmd(TIM4, ENABLE);  //ʹTIMx
//    TIM_ITConfig(TIM4, TIM_IT_Update, ENABLE);  //ʹָTIMж
  }
  //ʱԴ
  {
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

    TIM_TimeBaseInitStructure.TIM_Period = 1000 - 1;
    TIM_TimeBaseInitStructure.TIM_Prescaler = 72 - 1;
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseInitStructure);
    
    /* Master Mode selection: TIM3 */
    TIM_SelectMasterSlaveMode(TIM3, TIM_MasterSlaveMode_Enable);
    TIM_SelectOutputTrigger(TIM3, TIM_TRGOSource_Update);

//    TIM_ClearITPendingBit(TIM3, TIM_IT_Update);
    TIM3->CNT = 0;
    TIM_Cmd(TIM3, ENABLE);  //ʹTIMx
//    TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE);  //ʹָTIMж
  }
  
#ifdef USE_M_SYS_TIMER_GET_US
  //ϵͳusʱ
  {
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);

    TIM_TimeBaseInitStructure.TIM_Period = 0xFFFF;
    TIM_TimeBaseInitStructure.TIM_Prescaler = 72 - 1;
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM6, &TIM_TimeBaseInitStructure);

//    TIM_ClearITPendingBit(TIM6, TIM_IT_Update);
    TIM6->CNT = 0;
    TIM_Cmd(TIM6, ENABLE);  //ʹTIMx
//    TIM_ITConfig(TIM6, TIM_IT_Update, ENABLE);  //ʹָTIMж
  }
#endif
  
  //δʱ
  {
    SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK_Div8);	 //δʱʱѡⲿʱ8Ƶ72/8=9M
    SysTick->VAL = 0;
    SysTick->LOAD = tickReloadVal;
    SysTick->CTRL |= SysTick_CTRL_ENABLE_Msk;  //SYSTICK
  }
}

void delay(u32 time)
{
  while(time--);
}

void delay_us(u16 us)  //δʱǵʱ
{
	u32 us_tmp = us * 9;  //δƵ9M
	u32	tickBck = SysTick->VAL, tickNow = 0, cnt = 0;
	
	while(1)
	{
		tickNow = SysTick->VAL;
	  if(tickNow != tickBck)
		{
		  if(tickNow < tickBck)
			{
				cnt += (tickBck - tickNow);
			}
			else
			{
			  cnt += (tickReloadVal - tickNow + tickBck);
			}
			tickBck = tickNow;
		}
		if(cnt >= us_tmp)
		{
		  return;
		}
	}
}

static void delay_100ms(void)
{
	u32 ms_tmp = 100 * 9000;  //δƵ9M
	u32	tickBck = SysTick->VAL, tickNow = 0, cnt = 0;
	
	while(1)
	{
		tickNow = SysTick->VAL;
	  if(tickNow != tickBck)
		{
		  if(tickNow < tickBck)
			{
				cnt += (tickBck - tickNow);
			}
			else
			{
			  cnt += (tickReloadVal - tickNow + tickBck);
			}
			tickBck = tickNow;
		}
		if(cnt >= ms_tmp)
		{
		  return;
		}
	}
}

void delay_ms(u16 ms)
{
	u32 ms100 = ms / 100;
	u32 ms1 = ms % 100;
	
	for(int i = 0; i < ms100; i++)  //ʱms
	{
		mIWDG_feed();
		delay_100ms();
	}
	
	u32 ms_tmp = ms1 * 9000;  //δƵ9M
	u32	tickBck = SysTick->VAL, tickNow = 0, cnt = 0;
	
	while(1)
	{
		tickNow = SysTick->VAL;
	  if(tickNow != tickBck)
		{
		  if(tickNow < tickBck)
			{
				cnt += (tickBck - tickNow);
			}
			else
			{
			  cnt += (tickReloadVal - tickNow + tickBck);
			}
			tickBck = tickNow;
		}
		if(cnt >= ms_tmp)
		{
		  return;
		}
	}
}

#if SYSTEM_SUPPORT_OS == USE_OS_NONE
void delay_s(u16 s)
{
	for(int i = 0; i < s * 10; i++)
	{
		mIWDG_feed();
		delay_100ms();
	}
}
#endif

/*----------------------------------------------------------------------------------------
FreeRTOSûдȼĹܣ
FreeRTOSжǲBASEPRIĴرյĳֵжϣֵжϲرգ
----------------------------------------------------------------------------------------*/
//ǱҪҪжǶ
void mNVIC_config(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);  //ʹFreeRTOS4
	
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;  //1
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 8;  //FreeRTOS
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

void mIWDG_config(u8 prer, u16 rlr)
{
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);  //ʹܶԼĴIWDG_PRIWDG_RLRд
  IWDG_SetPrescaler(prer);  //IWDGԤƵֵ---48163264128256.
  IWDG_SetReload(rlr);  //IWDGװֵ
  IWDG_ReloadCounter();  //IWDGװؼĴֵװIWDG
  IWDG_Enable();  //ʹIWDG
}
//ιŹ
void mIWDG_feed(void)
{
  IWDG_ReloadCounter();
}

u16 mFLASH_readWord(u32 add)
{
  return *(__IO uint16_t *)add;
}

void mFLASH_readMoreData(u32 add, u16 buf[], u16 len)
{
	mPrintf("mFLASH_readMoreData() ָָȥ\r\n");
  for(u16 i = 0; i < len; i++)
  {
    buf[i] = mFLASH_readWord(add + i * 2);
  }
}

void mFLASH_writeMoreDataNoCache(u32 add, u16 dat[], u16 len)
{
  if((add < USER_FLASH_START_ADDRESS) || ((add + len * 2) > USER_FLASH_END_ADDRESS))
  {
		mError("mFLASH_writeMoreDataNoSave() Error\r\n");
    return;  //Ƿַ
  }

	u32 sector = 0, sectorAdd = 0;
  sector = (add - FLASH_BASE) / FLASH_SECTOR_SIZE;  //ַ
  sectorAdd = sector * FLASH_SECTOR_SIZE + FLASH_BASE;  //Ӧ׵ַ

  FLASH_Unlock();  //д
  FLASH_ErasePage(sectorAdd);  //
  for(u16 i = 0; i < len; i++)
  {
    FLASH_ProgramHalfWord(add + i * 2, dat[i]);
  }
  FLASH_Lock();  //д
}

static u16 mFLASH_cache[FLASH_SECTOR_SIZE / 2] = {0};  //д֮ǰȶ
void mFLASH_writeMoreDataCache(u32 add, u16 dat[], u16 len)
{
  if((add < USER_FLASH_START_ADDRESS) || ((add + len * 2) > USER_FLASH_END_ADDRESS))
  {
		mError("mFLASH_writeMoreDataSave() Error\r\n");
    return;  //Ƿַ
  }

	u32 sector = 0, sectorAdd = 0;
  sector = (add - FLASH_BASE) / FLASH_SECTOR_SIZE;  //ַ
  sectorAdd = sector * FLASH_SECTOR_SIZE + FLASH_BASE;  //Ӧ׵ַ
	
	mFLASH_readMoreData(sectorAdd, mFLASH_cache, FLASH_SECTOR_SIZE / 2);
	for(u16 i = 0; i < len; i++)  //ԭݣ
	{
		mFLASH_cache[(add - sectorAdd) / 2 + i] = dat[i];
	}

  FLASH_Unlock();  //д
  FLASH_ErasePage(sectorAdd);  //
  for(u16 i = 0; i < FLASH_SECTOR_SIZE / 2; i++)
  {
    FLASH_ProgramHalfWord(sectorAdd + i * 2, mFLASH_cache[i]);
  }
  FLASH_Lock();  //д
}

int fputc(int ch, FILE *f)
{
  USART_ClearFlag(USART2, USART_FLAG_TC);
  USART_SendData(USART2, (uint8_t)ch);
  while(USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);
  return ch;
}

int GetKey(void)
{
  while(!(USART2->SR & USART_FLAG_RXNE));
  return((int)(USART2->DR & 0x1FF));
}

//void mUSART1_config(u32 baudRate)
//{
//	GPIO_InitTypeDef GPIO_InitStructure;
//  USART_InitTypeDef USART_InitStructure;

//  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO | RCC_APB2Periph_USART1, ENABLE);

//  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;  //USART1_TX
//  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
//  GPIO_Init(GPIOA, &GPIO_InitStructure);
//  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;  //USART1_RX
//  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
//  GPIO_Init(GPIOA, &GPIO_InitStructure);
//	
//	USART_InitStructure.USART_BaudRate = baudRate;
//  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
//  USART_InitStructure.USART_StopBits = USART_StopBits_1;
//  USART_InitStructure.USART_Parity = USART_Parity_No;
//  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
//  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
//  USART_Init(USART1, &USART_InitStructure);  //USART1

//  USART_Cmd(USART1, ENABLE);
//  USART_ClearFlag(USART1, USART_FLAG_TC); //UARTĴ־λ
////  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);  //ʹUSART1ж
////	USART_ITConfig(USART1, USART_IT_IDLE, ENABLE);  //ʹUSART1 IDLEж
//}

//void USART1_IRQHandler(void)  //жϺ
//{
//	u8 clear = clear;
//  if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)  //һֽ
//  {
//		USART_ClearITPendingBit(USART1, USART_IT_RXNE);

//  }
//	if(USART_GetITStatus(USART1, USART_IT_IDLE) != RESET)  //յһ֡
//	{
//	  clear = USART1->SR;  //SRĴ
//		clear = USART1->DR;  //DRĴ(ȶSRٶDRIDLEж)

//	}
//}

void mUSART2_config(u32 baudRate)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);  //APB1

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;  //USART2_TX
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;  //USART2_RX
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = baudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART2, &USART_InitStructure);

  USART_Cmd(USART2, ENABLE);
  USART_ClearFlag(USART2, USART_FLAG_TC);  //USARTĴ־λ
//  USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);  //ʹUSART2ж
//	USART_ITConfig(USART2, USART_IT_IDLE, ENABLE);  //ʹUSART2 IDLEж
}

void USART2_IRQHandler(void)  //жϺ
{
  u8 clear = clear;
  if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)  //һֽ
  {
		USART_ClearITPendingBit(USART2, USART_IT_RXNE);

  }
	else if(USART_GetITStatus(USART2, USART_IT_IDLE) != RESET)  //յһ֡
	{
	  clear = USART2->SR;  //SRĴ
		clear = USART2->DR;  //DRĴ(ȶSRٶDRIDLEж)

	}
}

void mUSART3_config(u32 baudRate)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_AFIO, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE);  //APB1

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;  //USART3_TX
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
//  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;  //USART3_RX,
//  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
//  GPIO_Init(GPIOB, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = baudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
//  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_InitStructure.USART_Mode = USART_Mode_Tx;  //ڱĿֻ
  USART_Init(USART3, &USART_InitStructure);

  USART_Cmd(USART3, ENABLE);
  USART_ClearFlag(USART3, USART_FLAG_TC);  //USARTĴ־λ
//  USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);  //ʹUSART3ж
//	USART_ITConfig(USART3, USART_IT_IDLE, ENABLE);  //ʹUSART3 IDLEж
}

void USART3_IRQHandler(void)  //жϺ
{
  u8 clear = clear;
  if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET)  //һֽ
  {
		USART_ClearITPendingBit(USART3, USART_IT_RXNE);
		
  }
	else if(USART_GetITStatus(USART3, USART_IT_IDLE) != RESET)  //յһ֡
	{
	  clear = USART3->SR;  //SRĴ
		clear = USART3->DR;  //DRĴ(ȶSRٶDRIDLEж)
		
	}
}

void mUART4_config(u32 baudRate)
{
	GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC | RCC_APB2Periph_AFIO, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE);  //APB1-UART4

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;  //UART4_TX
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;  //UART4_RX
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = baudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(UART4, &USART_InitStructure);

  USART_Cmd(UART4, ENABLE);
  USART_ClearFlag(UART4, USART_FLAG_TC);  //USARTĴ־λ
//  USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);  //ʹUART4ж
//	USART_ITConfig(UART4, USART_IT_IDLE, ENABLE);  //ʹUART4 IDLEж
}

void UART4_IRQHandler(void)  //жϺ
{
  u8 clear = clear;
  if(USART_GetITStatus(UART4, USART_IT_RXNE) != RESET)  //һֽ
  {
		USART_ClearITPendingBit(UART4, USART_IT_RXNE);

  }
	if(USART_GetITStatus(UART4, USART_IT_IDLE) != RESET)  //յһ֡
	{
	  clear = UART4->SR;  //SRĴ
		clear = UART4->DR;  //DRĴ(ȶSRٶDRIDLEж)
		
	}
}

void mUART5_config(u32 baudRate)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD | RCC_APB2Periph_AFIO, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);  //APB1-UART5

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;  //UART5_TX
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;  //UART5_RX
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = baudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(UART5, &USART_InitStructure);  //UART5

  USART_Cmd(UART5, ENABLE);
	USART_ClearFlag(UART5, USART_FLAG_TC);  //UARTĴ־λ
//  USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);  //ʹUART5ж
//	USART_ITConfig(UART5, USART_IT_IDLE, ENABLE);  //ʹUART5 IDLEж
}

void UART5_IRQHandler(void)  //жϺ
{
  u8 clear = clear;
  if(USART_GetITStatus(UART5, USART_IT_RXNE) != RESET)  //һֽ
  {
		USART_ClearITPendingBit(UART5, USART_IT_RXNE);
		
  }
	else if(USART_GetITStatus(UART5, USART_IT_IDLE) != RESET)  //յһ֡
	{
	  clear = UART5->SR;  //SRĴ
		clear = UART5->DR;  //DRĴ(ȶSRٶDRIDLEж)
		
	}
}

void mTIMER2_Config(u16 TIM_period, u16 TIM_prescaler, u8 TIM_clockDivision)
{
  TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

  TIM_TimeBaseInitStructure.TIM_Period = TIM_period;
  TIM_TimeBaseInitStructure.TIM_Prescaler = TIM_prescaler;
  TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_clockDivision;
  TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
  TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStructure);

  TIM_ClearITPendingBit(TIM2, TIM_IT_Update);
  TIM_Cmd(TIM2, ENABLE);  //ʹTIMx
  TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);  //ʹָTIMж
}

void TIM2_IRQHandler(void)   //ʱ2жϺ
{
  if(TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
  {
		TIM_ClearITPendingBit(TIM2, TIM_IT_Update);  //жϱ־

  }
}

//void mTIMER3_Config(u16 TIM_period, u16 TIM_prescaler, u8 TIM_clockDivision)
//{
//  TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;

//  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

//  TIM_TimeBaseInitStructure.TIM_Period = TIM_period;
//  TIM_TimeBaseInitStructure.TIM_Prescaler = TIM_prescaler;
//  TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_clockDivision;
//  TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
//  TIM_TimeBaseInit(TIM3, &TIM_TimeBaseInitStructure);

//  TIM_ClearITPendingBit(TIM3, TIM_IT_Update);
//  TIM_Cmd(TIM3, ENABLE);  //ʹTIMx
//  TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE);  //ʹָTIMж
//}

//void TIM3_IRQHandler(void)   //ʱ3жϺ
//{
//  if(TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)
//  {
//		TIM_ClearITPendingBit(TIM3, TIM_IT_Update);  //жϱ־

//  }
//}



















