#ifndef _PUBLIC_H_
#define _PUBLIC_H_

#include "stm32f10x.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

extern const u32 M0xFFFFFFFF;

typedef enum {
  BOOL_NC    = 0x7FFFFFFF,  //ռ32Bits
  
	BOOL_OK    = 0x00000001,
  
  BOOL_FALSE = 0x00000000,
  BOOL_TRUE  = 0x00000001,
  
  BOOL_FAIL  = 0x00000000,
  BOOL_SUCC  = 0x00000001,
  
} MyBool;

/* ʽDebug Testע͵ */
#define mPrintf  printf
#define mError   printf
#define mDebug   printf
#define mTest    printf

#define USE_OS_NONE        0
#define USE_OS_FREERTOS    1
#define SYSTEM_SUPPORT_OS  USE_OS_FREERTOS  //ʹOS

#define STM32_DIS_ALL_INT   __set_FAULTMASK(1);  //ʧȫж
#define STM32_EN_ALL_INT    __set_FAULTMASK(0);  //ʹȫж
#define STM32_SYSTEM_RESET  __set_FAULTMASK(1); NVIC_SystemReset(); while(1);  //STM32λ

//õδʱж
#define USE_M_SYS_TIMER_GET_US

void mSysTimerCfg(void);
#define mSysTimerGetMs()  TIM4->CNT

#ifdef USE_M_SYS_TIMER_GET_US
  #define mSysTimerGetUs()  TIM6->CNT
#endif

//ʱ
void delay(u32 time);
void delay_us(u16 us);
void delay_ms(u16 ms);
#if SYSTEM_SUPPORT_OS == USE_OS_NONE
void delay_s(u16 s);
#endif

//NVICú
void mNVIC_config(void);

//Ź
void mIWDG_config(u8 prer, u16 rlr);
void mIWDG_feed(void);

//ڲFLASHдַΪż
//stm32F103x8 FLASH  128K  0x0800 0000--0x0801 FFFF
//stm32F103xC FLASH  256K  0x0800 0000--0x0803 FFFF
//stm32F103xE FLASH  512K  0x0800 0000--0x0807 FFFF
#define USER_FLASH_START_ADDRESS  0x0803F800  //СΪ2Kֽ(1)
#define USER_FLASH_END_ADDRESS    0x0803FFFF + 1
#define FLASH_SECTOR_SIZE    2048  //FLASHС256KΪ1024Ϊ2048

/* Ŀõд洢λö */


extern const u32 M0x55555555;  //ҪFLASH洢ݵı־
extern const u32 M0xFFFFFFFF;

u16 mFLASH_readWord(u32 add);
void mFLASH_readMoreData(u32 add, u16 buf[], u16 len);
void mFLASH_writeMoreDataNoCache(u32 add, u16 dat[], u16 len);
void mFLASH_writeMoreDataCache(u32 add, u16 dat[], u16 len);

//úģ
int fputc(int ch, FILE *f);
int GetKey(void);
//void mUSART1_config(u32 baudRate);
void mUSART2_config(u32 baudRate);
void mUSART3_config(u32 baudRate);
void mUART4_config(u32 baudRate);
void mUART5_config(u32 baudRate);

//ʱģ
void mTIMER2_Config(u16 TIM_period, u16 TIM_prescaler, u8 TIM_clockDivision);
//void mTIMER3_Config(u16 TIM_period, u16 TIM_prescaler, u8 TIM_clockDivision);

#endif



















